//+------------------------------------------------------------------+
//|                                                       AMA_AD.mq4 |
//|                               Copyright  2011, Nikolaj Ostapujk |
//|                                                  nikost@inbox.lv |
//+------------------------------------------------------------------+
//|                                                AMA optimized.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                Copyright  2004, by konKop,wellx |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "optimized by Rosh"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Magenta
#property indicator_color2 SlateBlue
#property indicator_color3 Salmon
#property indicator_color4 DodgerBlue
//---- input parameters
extern int periodAMA =14;
extern string Indicator = "1AD 2RSI 3CCI 4Moment 5St 6WPR 7DeMark";
extern int    select_indicator=1; //1-AD; 2-RSI; 3-CCI;  4-Momentum; 5-Stochastic;
extern double nfast=2.0;
extern double nslow=8.0;
extern double G=1.8;
extern int    AMA_Trend_Type=1;
//---- buffers
double AMAbuffer[];
double upAMA[];
double downAMA[];
double AbsBuffer[];

double AMA2Buffer[];
double SumAMABuffer[];
double StdAMA[];
double Ind[];

double slowSC,fastSC,dFS;
string  name,I1="AD",I2="RSI",I3="CCI",I4="Momentum",I5="Stochastic",I6="WPR",I7="DeMarker";
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
double Price(int i)
  {
//----
   double res;
//----
   switch (select_indicator)
 {
  case 1: res=iAD(NULL,0,i); break;
  case 2: res=iRSI(NULL,0,periodAMA,0,i); break;
  case 3: res=iCCI(NULL,0,periodAMA,0,i); break;
  case 4: res=iMomentum(NULL,0,periodAMA,0,i); break;
  case 5: res=iStochastic(NULL,0,periodAMA,3,3,1,0,0,i);break;
  case 6: res=iWPR(NULL,0,periodAMA,i);  break;
  case 7: res=iDeMarker(NULL,0,periodAMA,i); 
 }
   return(res);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,AMAbuffer);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,upAMA);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
   SetIndexBuffer(2,downAMA);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,Ind);
   
   SetIndexBuffer(4,AbsBuffer);
   SetIndexBuffer(5,AMA2Buffer);
   SetIndexBuffer(6,SumAMABuffer);
   SetIndexBuffer(7,StdAMA);
   
   if(select_indicator==1)
  {
   name=I1;
  }
 if(select_indicator==2)
  {
   name=I2;
   SetLevelValue(0,50.0);
   SetLevelValue(1,30.0);
   SetLevelValue(2,70.0);
  }
  if(select_indicator==3)
  {
   name=I3;
   SetLevelValue(0,0.0);
   SetLevelValue(1,100.0);
   SetLevelValue(2,-100.0);
   }
 if(select_indicator==4)
  {
   name=I4;
   SetLevelValue(0,100.0);
  }
 if(select_indicator==5)
  {
   name=I5;
   SetLevelValue(0,50.0);
   SetLevelValue(1,20.0);
   SetLevelValue(2,80.0);
  }
 if(select_indicator==6)
  {
   name=I6;
   SetLevelValue(0,-20.0);
   SetLevelValue(1,-80.0);
  }
 if(select_indicator==7)
  {
   name=I7;
   SetLevelValue(0,0.3);
   SetLevelValue(1,0.7);
  }
  IndicatorShortName(name+"( "+periodAMA+" )");
   slowSC=(2.0 /(nslow+1));
   fastSC=(2.0 /(nfast+1));
   dFS=fastSC-slowSC;
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   int i,limit,limit2;
   double Noise,ER,SSC,x;
   double SredneeAMA,SumKvadratAMA;
   double val1,val2;
   double dipersion;
   static bool debug=false;
   
   if (debug) return;
   if (counted_bars>0) 
      {
      limit=Bars-counted_bars; 
      limit2=limit;
      }
   if (counted_bars==0)
      {
      ArrayInitialize(AMAbuffer,0);
      ArrayInitialize(upAMA,0);
      ArrayInitialize(downAMA,0);
      ArrayInitialize(AbsBuffer,0);
      ArrayInitialize(AMA2Buffer,0);
      ArrayInitialize(SumAMABuffer,0);
      ArrayInitialize(StdAMA,0);
      ArrayInitialize(Ind,0);
      
      limit=Bars-1;
      /*
      for (i=limit;i>=0;i--)
         {
         AMAbuffer[i]=0;
         upAMA[i]=0;
         downAMA[i]=0;
         AbsBuffer[i]=0;
         NoiseBuffer[i]=0;
         ERBuffer[i]=0;
         SSCBuffer[i]=0;
         StdAMA[i]=0;
         }
      ArrayInitialize(,)
      */
      limit2=Bars-periodAMA-1;
      }
   limit--;
   limit2--;
   //Print("limit=",limit);
   //Print(" Abs");
   for (i=limit;i>=0;i--)
      {
      AbsBuffer[i]=MathAbs(Price(i)-Price(i+1));
      }   
   //Print(" Noise");
   for (i=limit2;i>=0;i--)
      {
      Noise=iMAOnArray(AbsBuffer,0,periodAMA,0,3,i)*periodAMA;
      if (Noise!=0) ER=MathAbs(Price(i)-Price(i+periodAMA))/Noise; else ER=0;
      SSC=MathPow(ER*dFS+slowSC,G);
      AMAbuffer[i]=(Price(i)*SSC+AMAbuffer[i+1]*(1-SSC));
      AMA2Buffer[i]=AMAbuffer[i]*AMAbuffer[i]+AMA2Buffer[i+1];//    
      SumAMABuffer[i]=SumAMABuffer[i+1]+AMAbuffer[i];
      Ind[i]=Price(i);
      }   
   //Print(" Std");
   for (i=limit2;i>=0;i--)
      {
      val1=0;
      val2=0;
      SredneeAMA=(SumAMABuffer[i]-SumAMABuffer[i+periodAMA])/periodAMA;
      SumKvadratAMA=AMA2Buffer[i]-AMA2Buffer[i+periodAMA];
      dipersion=SumKvadratAMA/periodAMA-SredneeAMA*SredneeAMA;
      if (dipersion<0)
         {
         StdAMA[i]=0;
         //Print(" ! :",DoubleToStr(dipersion,8));
         //Print("periodAMA=",periodAMA,"  Bars=",Bars,"    i=",i);
         //Print("Bar;Price;AbsBuffer;AMAbuffer;AMA2Buffer;SumAMABuffer;SredneeAMA");
//         Print(i,";",Price(i),";",AbsBuffer[i],";",AMAbuffer[i],";",AMA2Buffer[i],";",SumAMABuffer[i],";",(SumAMABuffer[i]-SumAMABuffer[i+periodAMA])/periodAMA);

         if (IsTesting()&&false)
            {
            Print("Bar;Price;AbsBuffer;AMAbuffer;AMA2Buffer;SumAMABuffer;SredneeAMA");
            for (int Z=Bars-1;Z>=i;Z--) Print(Z,";",Price(Z),";",AbsBuffer[Z],";",AMAbuffer[Z],";",AMA2Buffer[Z],";",SumAMABuffer[Z],";",(SumAMABuffer[Z]-SumAMABuffer[Z+periodAMA])/periodAMA);
            }
         //debug=true;

         }
      else StdAMA[i]=MathSqrt(dipersion);

      if (AMA_Trend_Type!=0)
         {
         if (MathAbs(AMAbuffer[i]-AMAbuffer[i+1])>G*Point)
            {
            if (AMAbuffer[i]-AMAbuffer[i+1]>0) val1=AMAbuffer[i];
            else val2=AMAbuffer[i];
            } 
         }
      else
         {
         if (MathAbs(AMAbuffer[i]-AMAbuffer[i+1])>G*StdAMA[i])
            {
            if (AMAbuffer[i]-AMAbuffer[i+1]>0) val1=AMAbuffer[i];
            else val2=AMAbuffer[i];
            } 
         }         
      upAMA[i]=val1;
      downAMA[i]=val2;
      }
   //Print("");

//----
   return(0);
  }
//+------------------------------------------------------------------+